LABORATORIES

The aim of laboratories is to master Java programming language at intermediate level (junior Java developer). During laboratories students solve simple problems related to the following elements of Java language:
1. Introduction to Java: concepts, syntax, definitions and notations, control structures, classes and packages
2. Java syntax: keywords, control flow, operators, expressions
3. Object Oriented Programming
4. Test Driven Development
5. Design methodologies: Getting Things Done
6. Generics and Collections: Introduction
7. Generics and Collections: Data Analysis
8. Concurrency
9. Input / output operations, data streams
10. Functional programming: Lambda Expressions
11. Advanced data analysis and integration techniques (Java & KDB)
12. Numerical simulations: methods for deterministic calculations
13. Numerical simulations: methods for stochastic problems
14. Hackathon 1
15. Hackathon 2

Students also work on a larger individual project combining theoretical knowledge gained during seminar with practical skills and knowledge gained in computer laboratory. The project goal is to develop an algorithmic trading bot working with provided trading platform simulator.

LECTURE
The aim of the lectures is to provide foundations of modern programming techniques and methodologies at intermediate level (junior Java developer). The content is closely correlated with progress of the group during laboratories. The theoretical knowledge is followed by practical examples. The presented materials are supplemented by live coding demonstration of bottom to top solutions. Considered topics covers (but do not limit to):

1. Introduction to Java and JVM, documentation
   - [Java Documentation](https://docs.oracle.com/en/java/)
   - [Java 19 Language Specification](https://docs.oracle.com/javase/specs/jls/se19/jls19.pdf)
   - [Java 19 Virtual Machine Specification](https://docs.oracle.com/javase/specs/jvms/se19/jvms19.pdf)
   - [Tha Java Tutorials](https://docs.oracle.com/javase/tutorial/)
   - [Essentials of the Java Programming Language: A Hands-On Guide, part 1](https://www.oracle.com/technical-resources/articles/java/basicjava-programming1.html)
   - [Essentials of the Java Programming Language: A Hands-On Guide, part 2](https://www.oracle.com/technical-resources/articles/java/basicjava-programming2.html)
   - [Learn and get assistance](https://www.jetbrains.com/idea/resources/)
   - [JetBrains: Getting started](https://www.jetbrains.com/help/idea/getting-started.html)
   - [JetBrains: Maven project](https://www.jetbrains.com/help/idea/delegate-build-and-run-actions-to-maven.html)
   - [Git](https://git-scm.com/download/win)
   - [IntelliJ IDEA](https://www.jetbrains.com/idea/download)
   - [Windows Terminal](https://aka.ms/terminal)
   - [Intellij IDEA Terminal](https://www.jetbrains.com/help/idea/terminal-emulator.html)
2. Data type model
3. Object Oriented Programming
4. Generics and Collection
5. Software design methodologies: Domain Driven Design, Test Driven Development, Behavior Driven Development
6. Design Patterns
7. Advanced programming techniques: reflection and proxy
8. Parallel and concurrent programming
9. Advanced data analysis and integration techniques
10. Classical computational problems
11. Data science and deep learning
12. Probability programming

Applied Java lectures, laboratories and hackathon are covered by HSBC patronage.

Literature
1. https://docs.oracle.com/en/java/javase/17/
2. OCP Oracle Certified Professional Java SE 17 Developer Study Guide: Exam 1Z0-829, Scott Selikoff, Jeanne Boyarsky, ISBN: 978-1-119-86458-5, May 2022
3. Effective Java, Joshua Bloch, ISBN: 9780134686097, December 2017
4. Modern Java in Action, Raoul-Gabriel Urma, Mario Fusco, Alan Mycroft, ISBN 9781617293566,
   September 2018
