### 1) class OverrideAnnotation: @Override annotation
`@Override` is an annotation marking that following method overrides a method from its
superclass. The method has to have exactly the same prototype as method in superclass.
```
public class OverrideAnnotation {
  @Override
  public String toString(String value) {
    return value;
  }
}
```
Why it doesn’t compile? How @Override annotation
helps to discover potential bugs and what would happen without it?

### 2) class CopyrightPrinter: Custom annotations

Create annotation @Copyright taking one parameter, describing copyright info.
Write a piece of code showing all method names in given class with their copyright
information. Example usage of your annotation:
```
class CopyrightExample {
  @Copyright(info = “(2009) Luxoft Inc.”)
  public void test() {}
}

```
Your task is to implement method
```
CopyrightPrinter.getMethodCopyrightInfo(Class<?> c)
```

### output:
```
Method "add" has annotation:(2022) Luxoft Inc.
Method "test" has annotation:(2009) Luxoft Inc.

```

<div class="hint">
  use isAnnotationPresent(Copyright.class) and getAnnotation(Copyright.class); on proper Method object
</div>