### Flyweight design pattern
Flyweight pattern is primarily used to reduce the number of objects created, to decrease memory
footprint and increase performance.

Flyweight pattern tries to reuse already existing similar kind objects by storing them and creates
new object when no matching object is found.

To apply the pattern, you need to create Flyweight factory which returns shared objects. Attached
source code contains simple implementation of application drawing shapes – lines and squares.
They both implement Shape interface. Square contains property defining whether it should be
filled with color; line doesn’t contain any such property. There are three possible shapes to draw –
`SQUARE`, `SQUARE_FILLED` and `LINE`.
`ShapeFactory.getShape(ShapeType st)` method returns new Shape instance every
time the method is called. Fix the implementation so it will keep created objects cached and when
`getShape` is executed many times for the same type (for example LINE) it will return the same
object. What are the benefits of this approach?
Add another method
```
public Shape getShape(ShapeType st, String color)
```
which behaves in the same way as getShape, but caches instances for every color separately.