## Reflection
Reflection is a mechanism that allows programs to examine (introspect) or modify the runtime
behavior of applications running in the JVM.


### 1) class AuthenticatorOverrider: Accessing private methods and members
Consider the following class:
```
public class Authenticator {
  private boolean authenticated = false;
  public void authenticate(String user, String password) {
    if (isValid(user, password)) {authenticated = true;}
  }
  public boolean isAuthenticated() {return authenticated;}
  // ...
}
```
At first, user is not authenticated and the only way to authenticate is to
execute method
`Authenticator.authenticate(String user, String password)`.
Your task is to implement two methods in class `AuthenticationOverrider`:
1. `forceAuthenticateByMethod(Authenticator auth)`
by executing private method which doesn’t use user or password, but after which
`auth.isAuthenticated()`
will return true. 

2. `forceAuthenticateByField(Authenticator auth)`
by changing private field’s value which doesn’t use user or password, but after which
`auth.isAuthenticated()`
will return true.  

<div class="hint">
  Use getClass
</div>


### 2) class Instantiator:  Create new instance of a class by its name

Implement:
```
public Object createInstance(String className) throws  ReflectiveOperationException
```
Your method should return if possible new instance of class denoted by className.
<div class="hint">
  use Class
</div>

