package org.example;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;
import java.util.concurrent.Callable;
import java.util.function.ToLongFunction;
import java.util.stream.IntStream;






public class Splitter {
    public static Collection<Callable<Long>> split(long[] vector, int n, ToLongFunction<long[]> f) {
        final int sliceLength = vector.length / n;
        final var cs = new ArrayList<Callable<Long>>();

        for(int i = 0; i < vector.length; i += sliceLength) {
            long[] vs = Arrays.copyOfRange(vector, i, Math.min(i + sliceLength, vector.length));
            cs.add(() -> f.applyAsLong(vs));
        }
        return cs;

    }
    interface Agregate{
        public long get(Collection<Callable<Long>> collection) throws Exception;
    }

    public static void main(String[] args) throws Exception {
        long[] data = {1,2,3,4};

        Collection<Callable<Long>> collection1 = split(data,2, x-> x.length);
        Collection<Callable<Long>> collection2 = split(data,2, x-> Arrays.stream(x).sum());
        Agregate agregate = collection -> {
            long sum = 0;
            for(var c : collection) {
                sum += c.call();
            }
            return sum;
        };

        System.out.println("Length of " + Arrays.toString(Arrays.stream(data).toArray()) +" = "+
                agregate.get(collection1));

        System.out.println("Sum of " + Arrays.toString(Arrays.stream(data).toArray()) +" = "+
                agregate.get(collection2));

    }


}