package org.example;

import java.time.Instant;
import java.util.Objects;

public class Person {
    private final Instant created;
    private final String name;
    private final Integer age;
    private final Address address;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof Person person)) return false;
        return Objects.equals(name, person.name) && Objects.equals(age, person.age) && Objects.equals(address, person.address);
    }

    @Override
    public int hashCode() {
        return Objects.hash(created, name, age, address);
    }

    public Person(Instant created, String name, Integer age, Address address) {
        this.name = name;
        this.age = age;
        this.address = address;
        this.created = created;
    }
}
