import java.lang.reflect.Method;
import java.util.ArrayList;



public class CopyrightPrinter {
    record Answer(String methodName, String copyrightInfo){
        @Override public String toString(){return "Method \"" + methodName()+"\" has annotation:" + copyrightInfo();}
    }

    public static void main(String[] args){
        gettMethodCopyrightInfo(CopyrightExample.class).forEach(System.out::println);
    }

    public static ArrayList<Answer> gettMethodCopyrightInfo(Class<?> c) {
        ArrayList<Answer> answers = new ArrayList<>();
        for (Method m : c.getDeclaredMethods()) {
            if(m.isAnnotationPresent(Copyright.class)){
                Copyright copyright = m.getAnnotation(Copyright.class);
                answers.add( new Answer(m.getName(),copyright.info()));
            }
        }
        return answers;
    }

}
