import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

import java.math.BigDecimal;

public class NumberCheckerTest {
    private final NumberChecker checker = new NumberChecker();

    @Test
    public void testPrimitive() {
        int i = 3;
        double d = 3.0;
        char c = '3';

        Assertions.assertTrue(checker.isNumber(i), "int variable is a number");
        Assertions.assertTrue(checker.isNumber(d), "double variable is a number");
        Assertions.assertFalse(checker.isNumber(c), "Character isn't a number");
    }

    @Test
    public void testObjects() {
        Integer i = 3;
        Double d = 3.0;
        Character c = '3';

        Assertions.assertTrue(checker.isNumber(i), "Integer object is a number");
        Assertions.assertTrue(checker.isNumber(d), "Double object is a number");
        Assertions.assertFalse(checker.isNumber(c), "Character object isn't a number");
    }

    @Test
    public void testBigDecimal() {
        BigDecimal bd = BigDecimal.valueOf(3);

        Assertions.assertTrue(checker.isNumber(bd), "BigDecimal object is a number");
    }
}
