import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

public class Geometry {
	private final List<Point> points;

	class Point {
		int x;
		int y;
		
		public Point(int x, int y) {
			this.x = x;
			this.y = y;
		}
        @Override
        public boolean equals(Object o){
            if (this == o) return true;
            if(!( o instanceof Point)) return false;
            Point that = (Point) o;
            return x == that.x && y == that.y;
        }
        @Override
        public int hashCode(){
            return Objects.hash(x,y);
        }
        @Override
        public String toString(){
            return "Point("+x+","+y+")";
        }
	}
	
    public Geometry() {
    	points = new ArrayList<>();
    }

    // should be equivalent to below but act only on Point class
    //public void addPoint(int x, int y) {
    //        for (int i = 0; i < points.size(); i++) {
    //            if (points.get(i).x == x && points.get(i).y == y) {
    //                System.out.println("The same point cannot be added twice to the geometry");
    //                return;
    //            }
    //        }
    //
    //        Point newPoint = new Point(x, y);
    //        points.add(newPoint);
    //
    //    }
    //
    public void addPoint(int x, int y) {
        Point newPoint = new Point(x,y);
        int index =  points.indexOf(newPoint);
        if (index < 0 )
            points.add(newPoint);
        else
            System.out.println("The same point cannot be added twice to the geometry");
    }

    //should be equivalent to below but act only on Point class
    //public void removePoint(int x, int y) {
    //    for (int i = 0; i < points.size(); i++) {
    //        if (points.get(i).x == x && points.get(i).y == y) {
    //            points.remove(i);
    //
    //            return;
    //        }
    //    }
    //
    //    System.out.println("Point (" + x + ", " + y + ") not found");
    //}
    public void removePoint(int x, int y) {
        if(! points.remove(new Point(x,y)))
            System.out.println("Point (" + x + ", " + y + ") not found");
    }

    public int getPointCount() {
        return points.size();
    }
}
