import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

public class GeometryTest {
    @Test
    public void testGetPointCount() {
        Geometry geometry = new Geometry();
        geometry.addPoint(1, 2);
        geometry.addPoint(1, 3);
        geometry.addPoint(1, 4);

        Assertions.assertEquals(3, geometry.getPointCount(), "3 points should be retrieved");
    }

    @Test
    public void testRemovePoint() {
        Geometry geometry = new Geometry();
        geometry.addPoint(1, 2);
        geometry.addPoint(1, 3);

        geometry.removePoint(1, 2);

        Assertions.assertEquals(1, geometry.getPointCount(), "Point should be removed from geometry");
    }

    @Test
    public void testRemoveNotAddedPoint() {
        Geometry geometry = new Geometry();
        geometry.addPoint(1, 2);
        geometry.addPoint(1, 3);

        geometry.removePoint(1, 4);

        Assertions.assertEquals(2, geometry.getPointCount(), "Point wasn't added before and nothing shouldn't be removed from geometry");
    }
}
