import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.Test;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class StringSorterTest {
    private static StringSorter sorter;

    @BeforeAll
    public static void setUp() {
        sorter = new StringSorter();
    }

    @Test
    public void testSortByLengthEmptyList() {
        List<String> empty = new ArrayList<String>();

        sorter.sortByLength(empty);

        Assertions.assertEquals(Collections.EMPTY_LIST, empty);
    }

    @SuppressWarnings("serial")
	@Test
    public void testSortByLength() {
        List<String> strings = new ArrayList<String>() {{
            add("short");
            add("verylong");
            add("medium");
            add("medium");
            add("mediUm");
            add("");
        }};

        List<String> expected = new ArrayList<String>() {{
            add("");
            add("short");
            add("medium");
            add("medium");
            add("mediUm"); // this should be in this place!
            add("verylong");
        }};

        int size = strings.size();

        sorter.sortByLength(strings);

        Assertions.assertEquals(size, strings.size(), "Size shouldn't change after sorting");
        Assertions.assertEquals(expected, strings, "List should be sorted by length");
    }
}
