import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;

public class OutputStreamOperatorUnSafe implements IOutputStreamOperator{
    private OutputStream stream;
    private boolean opened;

    public void write(byte[] buf) throws IOException {
        //try {
        try{
            initStream();
            writeToStream(buf);

            closeStream();
            //}
        }catch (IOException e) {
            System.out.println("Something went wrong! ");
        }
    }

   private  void initStream() throws IOException {
        opened = true;
        stream = new  FileOutputStream(new File(fileName));
    }

    private void writeToStream(byte[] buf) throws IOException {
        if (buf == null) {
            throw new IOException("Buffer can't be null");
        }

        stream.write(buf);
    }

    private void closeStream() throws IOException {
        opened = false;
        stream.close();
    }

    public boolean isOpened() {
        return opened;
    }

    public void finalize() throws Throwable {

      super.finalize();

        if (opened) {
            closeStream();
        }

    }
}
