import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.Test;

public class OutputStreamOperatorTest {
    private static OutputStreamOperator operator;

    @BeforeAll
    public static void setUp() {
        operator = new OutputStreamOperator();
    }

    @Test
    public void testOperateNullBuffer() throws Throwable {
        operator.write(null);

        // we're only checking behaviour after executing finalize
        operator.finalize();

        Assertions.assertFalse(operator.isOpened(), "Stream should be closed after calling finalize()");
    }

    @Test
    public void testOperate() throws Throwable {
        operator.write("abc".getBytes());

        // we're only checking behaviour after executing finalize
        operator.finalize();

        Assertions.assertFalse(operator.isOpened(), "Stream should be closed after calling finalize()");
    }
}
