import java.lang.reflect.Field;
import java.lang.reflect.Method;

public class AuthenticatorOverrider {
    public static void main(String[] args) throws ReflectiveOperationException {
        Authenticator auth1 = new Authenticator();
        System.out.println(""+auth1.toString() + "has  authenticated = "+ auth1.isAuthenticated());
        forceAuthenticateByMethod(auth1);
        System.out.println(""+auth1.toString() + "has  authenticated = "+ auth1.isAuthenticated());

        System.out.println();
        Authenticator auth2 = new Authenticator();
        System.out.println(""+auth2.toString() + "has  authenticated = "+ auth2.isAuthenticated());
        forceAuthenticateByField(auth2);
        System.out.println(""+auth2.toString() + "has  authenticated = "+ auth2.isAuthenticated());
    }
	public static void forceAuthenticateByMethod(Authenticator auth) throws ReflectiveOperationException {
        Method m = auth.getClass().getDeclaredMethod("doAuthentication");
        m.setAccessible(true);
        m.invoke(auth);
    }

    public static void forceAuthenticateByField(Authenticator auth) throws ReflectiveOperationException {
        Field f = auth.getClass().getDeclaredField("authenticated");
        f.setAccessible(true);
        f.set(auth,true);
    }
}
