import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.Test;

public class AuthenticatorOverriderTest {
    private static Authenticator auth;

    @BeforeAll
    public static void setUp() {
        auth = new Authenticator();
    }

	@Test
	public void testNotAuthenticated() throws Exception {
        Assertions.assertFalse(auth.isAuthenticated(), "Authenticator shouldn't be authenticated at first");
    }

    @Test
    public void testForceAuthenticateByMethod() throws Exception {
		AuthenticatorOverrider.forceAuthenticateByMethod(auth);

        Assertions.assertTrue(auth.isAuthenticated(), "Authenticator should be authenticated after executing override by method");
	}

    @Test
    public void testForceAuthenticateByMethodByField() throws Exception {
        AuthenticatorOverrider.forceAuthenticateByField(auth);

        Assertions.assertTrue(auth.isAuthenticated(), "Authenticator should be authenticated after executing override by changing field value");
    }
}
