import base.ICSVLine;

import java.util.Arrays;

public class CSVLine implements ICSVLine {
	private String[] parts;
		
	public CSVLine(String csvLine){
		parts = csvLine.split(delim, -1);
	}
	

	@Override
	public String[] getParts() {
		return parts;
	}
	

	@Override
	public String toCSV() {
		StringBuilder sb = new StringBuilder();
		for(String part: parts) {
			sb.append(part);
			sb.append(delim);
		} 
		
		// just to remove last coma
		if(sb.length() > 0) sb.deleteCharAt(sb.length()-1);
		return sb.toString(); 
	}

	/**
	 * I override default toString and default equals method,
	 * HashCode and Equals methods were auto generated by InteliJ
	 */
	@Override
	public String toString() {
		return Arrays.toString(parts);
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + Arrays.hashCode(parts);
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		CSVLine other = (CSVLine) obj;
		if (!Arrays.equals(parts, other.parts))
			return false;
		return true;
	}
}
