// Throw an exception from a lambda expression.
interface DoubleNumericArrayFunc {
    double func(double[] n) throws EmptyArrayException;
}
class EmptyArrayException extends Exception {
    EmptyArrayException() {
        super("Array Empty");
    }
}
public class LambdaExceptionDemo {
    public static void main(String[] args) throws EmptyArrayException {
        double[] values = { 1.0, 2.0, 3.0, 4.0 };

        System.out.println("The average is " + average(values));
        // This causes an exception to be thrown.
        System.out.println("The average is " + average(new double[0]));
    }

    public static double average(double[] vals) throws EmptyArrayException {
        // This block lambda computes the average of an array of doubles.
        DoubleNumericArrayFunc f = (n) -> {
            double sum = 0;
            if(n.length == 0)
                throw new EmptyArrayException();
            for(int i=0; i < n.length; i++)
                sum += n[i];
            return sum / n.length;
        };
        return f.func(vals);
    }
}