package org.example;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;

import java.lang.reflect.Modifier;

public class InheritanceTests {
    @Test
    @DisplayName("org.example.Employee class is a subclass of org.example.Person class")
    public void testEmployeeIsPersonSubclass() {
        Assertions.assertTrue(Person.class.isAssignableFrom(Employee.class));
    }

    @Test
    @DisplayName("org.example.Person class is abstract")
    public void testPersonIsAbstract() {
        Assertions.assertTrue(Modifier.isAbstract(Person.class.getModifiers()));
    }

    @Test
    @DisplayName("org.example.Person has an address")
    public void testPersonHasAddress() {
        var field = Assertions.assertDoesNotThrow(() -> Person.class.getDeclaredField("address"));
        Assertions.assertEquals(Address.class, field.getType());
    }
}