package org.example;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

class EvenTest {
    @Test
    void keepOrder() {
        final var actual = Even.even(new Integer[]{1, 2, 2, 3, 5, 7, 4, 2});
        final var expected = new Integer[]{2, 2, 4, 2};

        Assertions.assertArrayEquals(expected, actual);
    }

    @Test
    void duplicates() {
        final var actual = Even.even(new Integer[]{1, 2, 2, 3, 2});
        final var expected = new Integer[]{2, 2, 2};

        Assertions.assertArrayEquals(expected, actual);
    }

    @Test
    void simple() {
        final var actual = Even.even(new Integer[]{1, 2, 3});
        final var expected = new Integer[]{2};

        Assertions.assertArrayEquals(expected, actual);
    }

    @Test
    void nullArray() {
        final var actual = Even.even(null);
        Assertions.assertNull(actual);
    }

    @Test
    void emptyArray() {
        final var actual = Even.even(new Integer[]{});
        final var expected = new Integer[]{};

        Assertions.assertArrayEquals(expected, actual);
    }
}