package org.example;

import java.util.ArrayList;
import java.util.Arrays;

// Press Shift twice to open the Search Everywhere dialog and type `show whitespaces`,
// then press Enter. You can now see whitespace characters in your code.
public class SolutionDay02 {
    public static int part1(String input) {
        final var reports = input.lines()
                .map(line -> {
                    final var split = line.split(" ");
                    return Arrays.stream(split).mapToInt(Integer::valueOf).toArray();
                })
                .toList();

        var sum = 0;
        for (var report: reports) {
            final var safe = evaluate(report);
            sum += safe;
        }

        return sum;
    }

    private static int checkIncreasing(int[] report, int index) {
        if (report.length == index) {
            return 1;
        }

        final var dist = report[index - 1] - report[index];

        if (1 <= dist && dist <= 3) {
            return checkIncreasing(report, index + 1);
        }

        return 0;
    }

    private static int checkDecreasing(int[] report, int index) {
        if (report.length == index) {
            return 1;
        }

        final var dist = report[index - 1] - report[index];

        if (-3 <= dist && dist <= -1) {
            return checkDecreasing(report, index + 1);
        }

        return 0;
    }

    private static int evaluate(int[] report) {
        if (checkIncreasing(report, 1) == 1) {
            return 1;
        }
        return checkDecreasing(report, 1);
    }

    public static int part2(String input) {
        final var reports = input.lines()
                .map(line -> {
                    final var split = line.split(" ");
                    return Arrays.stream(split).mapToInt(Integer::valueOf).toArray();
                })
                .toList();

        var sum = 0;
        for (var report: reports) {
            final var safe = evaluate(report);
            if (safe == 0) {
                for(var i = 0; i < report.length; i++) {
                    final var fixed = new int[report.length - 1];
                    for(int j = 0, k = 0; j < report.length; j++) {
                        if (j != i) {
                            fixed[k] = report[j];
                            k++;
                        }
                    }
                    if (evaluate(fixed) == 1) {
                        sum += 1;
                        break;
                    }
                }
            } else {
                sum += safe;
            }
        }

        return sum;
    }
}