package org.example;

import org.example.renderable.Renderable;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

public class Board {
    public final int width;
    public final int height;
    private final char[] tbl;

    Board(int width, int height) {
        this.width = width;
        this.height = height;
        this.tbl = new char[height * width];
        initialize();
    }

    private void initialize() {
        final var rg = new Random();
        for (int i = 0; i < width; i++) {
            for (int j = 0; j < height; j++) {
                if (0 < i && i < width - 1 && 0 < j && j < height - 1 && rg.nextDouble() < 0.8) {
                    tbl[j * width + i] = ' ';
                } else {
                    tbl[j * width + i] = 'x';
                }
            }
        }
    }

    public void render(Renderable renderable) {
        renderable.render(tbl, height, width);
    }

    public boolean valid(int j, int i) {
        return tbl[j * width + i] == ' ';
    }
}
