package org.example;

import org.example.renderable.Renderable;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Random;

public class Game {
    private final Board board;

    private List<Player> players;
    private List<Item> items;

    public Game(Board board) {
        this.board = board;
        this.players = new ArrayList<>();
        this.items = new ArrayList<>();
    }

    public void render() {
        for (var player: players) {
            System.out.println("row: " + player.getLocation().y + ", column: " + player.getLocation().x);
        }
    }

    public Player player(String name) {
        final var player = new Player(name);
        final var rg = new Random();

        outer: while(true) {
            final var point = new Point(rg.nextInt(board.height), rg.nextInt(board.width));
            if (!board.valid(point.y, point.x)) {
                continue;
            }

            for(var p: players) {
                if (p.getLocation().y == point.y && p.getLocation().x == point.x) {
                    continue outer;
                }
            }

            player.setLocation(point);
            players.add(player);
            return player;
        }
    }
}
