package org.example.renderable;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;

public class FileRenderable implements Renderable {
    private final String filePath;

    public FileRenderable(String filePath) {
        this.filePath = filePath;
    }

    @Override
    public void render(char[] tbl, int height, int width) {
        try (BufferedWriter writer = new BufferedWriter(new FileWriter(filePath))) {
            for (int i = 0; i < tbl.length; i++) {
                writer.write(tbl[i]); // Write each row to the file
                if (i % width == width - 1) {
                    writer.newLine(); // Add a new line after each row
                }
            }
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }
}
