package org.example;

import java.util.ArrayList;
import java.util.function.Function;
import java.util.stream.Collectors;

import static java.util.stream.Collectors.groupingBy;

// Press Shift twice to open the Search Everywhere dialog and type `show whitespaces`,
// then press Enter. You can now see whitespace characters in your code.
public class SolutionDay01 {
    public static int part1(String input) {
        final var lines = input.lines().toList();

        final var left = new ArrayList<Integer>();
        final var right = new ArrayList<Integer>();

        for (final var line : lines) {
            final var split = line.split(" {3}");
            final var leftNumber = Integer.valueOf(split[0]);
            final var rightNumber = Integer.valueOf(split[1]);

            left.add(leftNumber);
            right.add(rightNumber);
        }

        left.sort(Integer::compareTo);
        right.sort(Integer::compareTo);

        //
        var sum = 0;

        for (var i = 0; i < left.size(); i++) {
            var dist = Math.abs(left.get(i) - right.get(i));
            sum += dist;
        }

        return sum;
    }

    public static long part2(String input) {
        final var lines = input.lines().toList();

        final var left = new ArrayList<Integer>();
        final var right = new ArrayList<Integer>();

        for (final var line : lines) {
            final var split = line.split(" {3}");
            final var leftNumber = Integer.valueOf(split[0]);
            final var rightNumber = Integer.valueOf(split[1]);

            left.add(leftNumber);
            right.add(rightNumber);
        }

        final var frequencies = right.stream()
                .collect(groupingBy(Function.identity(), Collectors.counting()));

        var sum = 0L;
        for (var l : left) {
            sum += l * frequencies.getOrDefault(l, 0L);
        }

        final var right_map = right.stream().collect(groupingBy(Integer::valueOf,
                Collectors.counting()));
        final var sum_2 = left.stream()
                .mapToLong(x -> x * right_map.getOrDefault(x, 0L))
                .sum();

        return sum_2;
    }
}