package org.example;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;

import static org.junit.jupiter.api.Assertions.*;

class SolutionDay02Test {
    private static final String TEST_INPUT = """
            7 6 4 2 1
            1 2 7 8 9
            9 7 6 2 1
            1 3 2 4 5
            8 6 4 4 1
            1 3 6 7 9
            """;

    @Test
    void part1() throws IOException {
        final var expected = 2;
        final var actual = SolutionDay02.part1(TEST_INPUT);

        Assertions.assertEquals(expected, actual);

        final var result = SolutionDay02.part1(Files.readString(Path.of("data/day02.txt")));
        System.out.println(result);
    }

    @Test
    void part2() throws IOException {
        final var expected = 4;
        final var actual = SolutionDay02.part2(TEST_INPUT);

        Assertions.assertEquals(expected, actual);

        final var result = SolutionDay02.part2(Files.readString(Path.of("data/day02.txt")));
        System.out.println(result);
    }
}